<?php

 function putNavigator($title,$current,$total,$link,$l_pagecount)
 {
  $pagecount = 0;
  if($l_pagecount!=0)
  {
   $pagecount = ceil($total/$l_pagecount);
  }

  if($pagecount>0)
  {
   echo $title;
  }

  for($i=0;$i<$pagecount;$i++)
  {
   $start = $i*$l_pagecount;
   $end = $start+($l_pagecount-1);

   if($start>=$total)
   {
    $start = $total-1;
   }

   if($end>=$total)
   {
    $end = $total-1;
   }

   $lstart = $start+1;
   $lend = $end+1;

   echo "<A HREF='$link&amp;start=$start'>";
   if($start==$current)
   {
    echo "<STRONG>$lstart-$lend</STRONG>";
   }
   else
   {
    echo "$lstart-$lend";
   }
   echo "&nbsp;</A>";
  }

  echo "<BR />";
 }

 function putHeader($header,$rsslink="")
 {
  global $col_headerbg,$col_headerfg;

  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='0' CELLSPACING='0'>";
  echo "<TR BGCOLOR='".$col_headerbg."'><TD>&nbsp;&nbsp;";
  echo "<FONT COLOR='".$col_headerfg."'><STRONG>$header</STRONG></FONT></TD>";
  if($rsslink!="")
  {
   echo "<TD VALIGN='MIDDLE' ALIGN='RIGHT'><A HREF='$rsslink'><IMG ALT='RSS' BORDER='0' SRC='images/rsslink.gif' /></A></TD>";
  }
  echo "</TR></TABLE>";
 }

 function putTopMenuItem($link,$label)
 {
  global $col_topmenufg;

  echo "&nbsp;&nbsp;<A HREF='$link'><STRONG><FONT COLOR='$col_topmenufg'>$label</FONT></STRONG></A>";
 }

 function putMenuItem($link,$label,$level=0)
 {
  global $col_menufg,$col_menulinkfg;

  for($i=0;$i<$level;$i++)
  {
   echo "&nbsp;&nbsp;";
  }

  if($link!="")
  {
   echo "<A HREF='$link'>";
   $col = $col_menulinkfg;
  }
  else
  {
   $col = $col_menufg;
  }

  if($level==0)
  {
   echo "<STRONG>&nbsp;<FONT COLOR='$col'>$label</FONT></STRONG>";
  }
  else if($level==1)
  {
   echo "&nbsp;<FONT COLOR='$col'>$label</FONT>";
  }
  else
  {
   echo "<I>&nbsp;<FONT COLOR='$col'>$label</FONT></I>";
  }

  if($link!="")
  {
   echo "</A>";
  }
 }


 // Transforms a bbcode tagged text to html.
 // WARNING! Slow and horrible code below!
 // - Only transforms complete bbcode tags with both start and end tag.
 // - bbcode in [code][/code] segments are not transformed
 // - Does not handle out of order tags, such as:
 //   [b] bold [i][/b] italics [/i] will result in:
 //   <STRONG> bold <EM> </STRONG> italics </EM>
 // - All bbcode must be in lowercase
 // - newlines in non code segments are translated to <BR />
 // if class_bbparser.php is loaded the the code below won't be used.
 function bbToHTML($text,$image=true)
 {
  global $col_tableframe,$col_quotebg;
  global $col_tableheaderbg,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2,$g_dis;
  global $g_bbparser;

  if(is_object($g_bbparser))
  {
   return $g_bbparser->parse(htmlentities($text,ENT_QUOTES,'ISO-8859-15',false));
  }

  // ToDo: Need to find a better way to handle umlauts and such
  $text = str_replace("&auml;","\0x38auml;",$text);
  $text = str_replace("&Auml;","\0x38Auml;",$text);
  $text = str_replace("&aring;","\0x38aring;",$text);
  $text = str_replace("&Aring;","\0x38Aring;",$text); 
  $text = str_replace("&ouml;","\0x38ouml;",$text);
  $text = str_replace("&Ouml;","\0x38Ouml;",$text);
  $text = str_replace("&amp;","\0x38amp;",$text);
  $text = htmlentities($text,ENT_QUOTES);
  $text = str_replace("\0x38","&",$text);

  $ar1 = preg_split("#(\[code\].*?\[/code\])#si",$text,-1,PREG_SPLIT_DELIM_CAPTURE);
  // Find out if quoting should be made
  $ar2 = preg_split("#(\[code\].*?\[/code\])#si",$text,-1);
  $tmpstr = implode("",$ar2); 
  $cnt1 = substr_count($tmpstr,"[quote]");
  $cnt2 = substr_count($tmpstr,"[/quote]");
  $quoteIt = $cnt1>0 && $cnt1==$cnt2;

  $codes = array();

  $codes["#\[b\](.*?)\[/b\]#si"] = "<STRONG>\\1</STRONG>";
  $codes["#\[i\](.*?)\[/i\]#si"] = "<EM>\\1</EM>";
  $codes["#\[u\](.*?)\[/u\]#si"] = "<U>\\1</U>";
  $codes["#\[s\](.*?)\[/s\]#si"] = "<STRIKE>\\1</STRIKE>";
  $codes["#\[color=(.*?)\](.*?)\[/color\]#si"] = "<FONT COLOR='\\1'>\\2</FONT>";
  if($image)
  {
   $codes["#\[img\](.*?)\[/img\]#si"] = "<IMG SRC='\\1' BORDER='0' ALT='Image' />";
   $codes["#\[img=(.*?)\](.*?)\[/img\]#si"] = "<A HREF='\\1'><IMG SRC='\\2' BORDER='0' ALT='Image' /></A>";
  }
  $codes["#\[url=(.*?)\](.+?)\[/url\]#si"] = "<A HREF='\\1'>\\2</A>";
  $codes["#\[url\](.*?)\[/url\]#si"] = "<A HREF='\\1'>\\1</A>";
  // $codes["#\[url=(.*?)\]\[/url\]#si"] = "<A HREF='\\1'>\\1</A>";
  $codes["#\[email\](.*?)\[/email\]#si"] = "<A HREF='mailto:\\1'>\\1</A>";
  $codes["#\[large\](.*?)\[/large\]#si"] = "<FONT SIZE='+1'>\\1</FONT>";
  $codes["#\[large=(.*?)\](.*?)\[/large\]#si"] = "<FONT COLOR='\\1' SIZE='+1'>\\2</FONT>";
  $codes["#\[small\](.*?)\[/small\]#si"] = "<FONT SIZE='-2'>\\1</FONT>";
  $codes["#\[small=(.*?)\](.*?)\[/small\]#si"] = "<FONT COLOR='\\1' SIZE='-2'>\\2</FONT>";
  $codes["#\[center\](.*?)\[/center\]#si"] = "<CENTER>\\1</CENTER>";
  $codes["#\[tag\](.*?)\[/tag\]#si"] = "<A ID=\\1></A>";
  $codes["#\[tab\]#si"] = "&nbsp;&nbsp;&nbsp;&nbsp;";
  $codes["#\[sub\](.*?)\[/sub\]#si"] = "<TABLE BORDER='0' CELLSPACING='0' CELLPADDING='0'><TR><TD>&nbsp;&nbsp;&nbsp;&nbsp;</TD><TD>\\1</TD></TR></TABLE>";

  $output = "";

  for($i=0;$i<count($ar1);$i++)
  {
   $snippet = $ar1[$i];
   $start = strpos($snippet, "[code]");
   $end = strrpos($snippet, "[/code]");

   if(strlen($snippet)>7 && is_numeric($start) && is_numeric($end) && $start==0 && $end == strlen($snippet)-7)
   {
    $output.= codeToHTML(substr($snippet,6,strlen($snippet)-13));
   }
   else
   {
    foreach ($codes AS $search => $replace)
    {
     if($quoteIt)
     {
      $snippet = str_replace("[quote]","<TABLE BORDER='0' CELLPADDING='0' CELLSPACING='1' WIDTH='100%'><TR><TD BGCOLOR='$col_tableframe'><TABLE BORDER='0' CELLSPACING='1' CELLPADDING='4' WIDTH='100%'><TR><TD BGCOLOR='$col_quotebg'>",$snippet);
      $snippet = str_replace("[/quote]","</TD></TR></TABLE></TD></TR></TABLE>",$snippet);
     }
     $snippet = preg_replace($search, $replace, $snippet);
    }
   $output.= str_replace("\n","<BR />",$snippet);
   }
  }

  return $output;
 }

 function codeToHTML($snippet)
 {
  global $col_codebg,$col_codefg,$col_tableframe;
  return "<TABLE BORDER='0' CELLSPACING='0' CELLPADDING='1' WIDTH='100%'><TR BGCOLOR='$col_tableframe'><TD><TABLE BORDER='0' CELLSPACING='0' CELLPADDING='4' WIDTH='100%'><TR><TD BGCOLOR='$col_codebg'><PRE>$snippet</PRE></TD></TR></TABLE></TD></TR></TABLE>";
 }

 function listNotes($notes,$buttons=true,$full=false)
 {
  global $g_projectstatuses,$g_categories;
  global $col_tablemediumbg,$col_tablelightbg;
  global $col_tableshinebg,$col_tabledarkbg;
  global $col_tableheaderbg,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2;
  global $col_tableframe,$col_errcolfg;
  global $g_stddatetime;
  global $g_users;
  global $g_user;

  if(!is_array($notes))
  {
   $notes = array();
  }

  foreach($notes AS $id => $note)
  {
   $title = $note->title;
   $synopsis = $note->synopsis;
   $text = $note->text;
   $createdDate = $note->createdDate;
   $createdByUserID = $note->createdByUserID;
   $createdByUser = $g_users->getUserByID($createdByUserID);
   $createdBy = $createdByUser->username;
   $created = date($g_stddatetime,$createdDate);

   echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='1'>";
   echo "<TR BGCOLOR='$col_tableframe'><TD>";
   echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='0'>";
   echo "<TR BGCOLOR='$col_tableheaderbg'><TD WIDTH='100%'><A HREF='?function=viewcomments&amp;noteid=$id&amp;full=true'><STRONG><FONT COLOR='$col_tableheaderfg'>$title</FONT></STRONG></A></TD>";
   echo "<TD NOWRAP><A HREF='?function=viewprofile&amp;userid=$createdByUserID'><FONT COLOR='$col_tableheaderfg'>Posted by $createdBy at $created</FONT></A></TD></TR>";
   echo "<TR BGCOLOR='$col_tableshinebg'><TD COLSPAN='2'>".bbToHTML($synopsis);
   if($full && $text!="")
   {
    echo "<BR /><BR />".bbToHTML($text);
   }
   echo "</TD></TR>";
   echo "<TR BGCOLOR='$col_tablemediumbg'><TD>";

   if($buttons)
   {
    echo functionLink("?function=viewcomments&amp;noteid=$id&amp;full=true","Read More");
    if(is_object($g_user) && $g_user->access("MODERATOR"))
    {
     echo functionLink("?function=deletenote&amp;noteid=$id","Delete News");
     echo functionLink("?function=editnote&amp;noteid=$id","Edit News");
    }
    echo "</TD><TD ALIGN='RIGHT'>";
    if($note->commentCount > 0)
    {
     echo functionLink("?function=viewcomments&amp;noteid=$id#$note->commentCount","$note->commentCount Comments",false);
    }
    else if(is_object($g_user) && $g_user->access("USER"))
    {
     echo functionLink("?function=addcomment&amp;noteid=$id","Add Comment",false);
    }
   }
   else
   {
    echo "&nbsp;</TD><TD>";
   }
   
   echo "</TD></TR>";

   echo "</TABLE></TD></TR></TABLE>";

  }
  
 }

 function listComments($comments,$projectid=0,$historyid=0,$noteid=0,$threadid=0,$showbuttons=true)
 {
  global $g_projectstatuses,$g_categories;
  global $col_tablemediumbg,$col_tablelightbg;
  global $col_tableshinebg,$col_tabledarkbg;
  global $col_tableheaderbg,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2;
  global $col_tableframe,$col_errcolfg;
  global $g_stddatetime;
  global $g_users;
  global $g_user;

  if(!is_array($comments))
  {
   $comments = array();
  }

  foreach($comments AS $id => $comment)
  {
   $createdbyuserid = $comment->createdByUserID;
   $createdbyip = $comment->createdByIP;
   $created = date($g_stddatetime,$comment->createdDate);
   $user = $g_users->getUserByID($createdbyuserid);
   $username = $user->username;
   $locked = $comment->locked;

   $title = $comment->title;
   $text = bbToHTML($comment->text);

   $avatar = $user->getAvatarURL();
   if($avatar=="")
   {
    $avatar = "images/avatars/anonymous.gif";
   }

   echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='1'>";
   echo "<TR BGCOLOR='$col_tableframe'><TD>";
   echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='0'>";

   echo "<TR BGCOLOR='$col_tableheaderbg'>";
   echo "<TD ALIGN='CENTER'><A HREF='?function=viewprofile&amp;userid=$createdbyuserid'><STRONG><FONT COLOR='$col_tableheaderfg'>$username</FONT></STRONG></A></TD>";
   echo "<TD WIDTH='100%'>";
   if($locked==1)
   {
    echo "<FONT COLOR='$col_errcolfg'><STRONG>LOCKED&nbsp;</STRONG></FONT>";
   }
   echo "<FONT COLOR='$col_tableheaderfg'>".htmlentities($title,ENT_QUOTES)."</FONT></TD>";
   echo "<TD ALIGN='RIGHT' NOWRAP><FONT COLOR='$col_tableheaderfg'>";
   if(is_object($g_user) && $g_user->access("MODERATOR"))
   {
    echo "$createdbyip&nbsp;&nbsp;&nbsp;";
   }
   echo "$created</FONT>";
   echo "</TD>";
   echo "</TR>";

   echo "<TR>";
   echo "<TD VALIGN='TOP' BGCOLOR='$col_tableshinebg'><IMG ALT='' SRC='$avatar'/></TD>";
   echo "<TD COLSPAN='2' VALIGN='TOP' BGCOLOR='$col_tablelightbg'>$text</TD></TR>";

   echo "<TR BGCOLOR='$col_tablemediumbg'>";
   echo "<TD COLSPAN='2' ALIGN='LEFT' BGCOLOR='$col_tablemediumbg'>";
   if(!$showbuttons)
   {
    echo "&nbsp;</TD><TD></TD>";
   }
   else
   {
    if(is_object($g_user) && $g_user->access("MODERATOR"))
    {
     if($comment->isLocked())
     {
      $lock_link = "unlockid=$id";
      $lock = "Unlock Comment";
     
     }
     else
     {
      $lock_link = "lockid=$id";
      $lock = "Lock Comment";
     }

     if($noteid!=0)
     {
      echo functionLink("?function=deletecomment&amp;noteid=$noteid&amp;commentid=$id","Delete Comment");
      echo functionLink("?function=viewcomments&amp;noteid=$noteid&amp;$lock_link",$lock);
     }
     else if($threadid!=0)
     {
      echo functionLink("?function=deletecomment&amp;threadid=$threadid&amp;commentid=$id","Delete Comment");
      echo functionLink("?function=viewcomments&amp;threadid=$threadid&amp;$lock_link",$lock);
     }
    }

    if(is_object($g_user) && !$g_user->access("NOTVALIDATED") && ($g_user->access(MODERATOR) || ($g_user->userID == $user->userID) && $locked==0))
    {
     if($noteid!=0)
     {
      echo functionLink("?function=editcomment&amp;noteid=$noteid&amp;commentid=$id","Edit Comment");
     }
     else if($threadid!=0)
     {
      echo functionLink("?function=editcomment&amp;threadid=$threadid&amp;commentid=$id","Edit Comment");
     }
    }

    echo "</TD><TD ALIGN='RIGHT'>";

    if(is_object($g_user) && $g_user->access("USER"))
    {
     if($noteid!=0)
     {
      echo functionLink("?function=addcomment&amp;noteid=$noteid&amp;replyid=$id","Reply");
     }
     else if($threadid!=0)
     {
      echo functionLink("?function=addcomment&amp;threadid=$threadid&amp;replyid=$id","Reply");
     }
    }
   }
   echo "</TD>";
   echo "</TR>";

   echo "</TABLE></TD></TR></TABLE>";
  }

 }

 function listPages($pages,$buttons=true)
 {
  global $g_projectstatuses,$g_categories;
  global $col_tablemediumbg,$col_tablelightbg;
  global $col_tableshinebg,$col_tabledarkbg;
  global $col_tableheaderbg,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2;
  global $col_tableframe,$col_errcolfg;
  global $g_stddatetime;
  global $g_users;
  global $g_user,$g_dis;

  if(!is_array($pages))
  {
   $pages = array();
  }

  echo "<TABLE BORDER='0' CELLPADDING='1' CELLSPACING='1'>";
  echo "<TR BGCOLOR='$col_tableframe'><TD>";
  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='0'>";
  echo "<TR BGCOLOR='$col_tableheaderbg'>";
  echo "<TD><FONT COLOR='$col_tableheaderfg'>ID$g_dis</FONT></TD>";
  echo "<TD><FONT COLOR='$col_tableheaderfg'>Name$g_dis</FONT></TD>";
  echo "<TD><FONT COLOR='$col_tableheaderfg'>Title$g_dis</FONT></TD>";
  echo "<TD><FONT COLOR='$col_tableheaderfg'>Menu$g_dis</FONT></TD>";
  echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Top Menu$g_dis</FONT></TD>";
  if(is_object($g_user) && $g_user->access("MODERATOR"))
  {
   echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Order$g_dis</FONT></TD>";
   echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Access$g_dis</FONT></TD>";
   echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Action</FONT></TD>";
  }
  echo "</TR>";

  $bgcol = $col_tablebg1;

  foreach($pages AS $pageID => $page)
  {
   $menu = "no";
   $topmenu = "no";

   if($page->menu==1)
   {
    $menu = "yes";
   }

   if($page->topMenu==1)
   {
    $topmenu = "yes";
   }

   echo "<TR BGCOLOR='$bgcol'>";
   echo "<TD>$pageID</TD>";
   echo "<TD NOWRAP><A HREF='?function=viewpage&amp;pageid=$pageID'>".htmlentities($page->name,ENT_QUOTES)."$g_dis</A></TD>";
   echo "<TD NOWRAP>".htmlentities($page->menuTitle,ENT_QUOTES)."$g_dis</TD>";
   echo "<TD>$menu</TD>";
   echo "<TD>$topmenu</TD>";
   if(is_object($g_user) && ($g_user->access("EDITPAGES") || $g_user->access("DELETEPAGES")))
   {
    echo "<TD>$page->sortOrder</TD>";
    echo "<TD NOWRAP>$page->access</TD>";
    echo "<TD NOWRAP>";
    if($g_user->access("EDITPAGES"))
    {
     echo functionLink("?function=editpage&amp;pageid=$pageID","Edit");
    }
    if($buttons && $g_user->access("DELETEPAGES"))
    {
     echo functionLink("?function=deletepage&amp;pageid=$pageID","Delete");
    }
    echo "</TD>";
   }
   echo "</TR>";

   if($bgcol == $col_tablebg1)
   {
    $bgcol = $col_tablebg2;
   }
   else
   {
    $bgcol = $col_tablebg1;
   }
  }

  echo "</TABLE>";
  echo "</TD></TR></TABLE>";

 }

 function listProfileComments($comments,$isProject=false,$isHistory=false,$isNote=false,$isThread=false)
 {
  global $g_projectstatuses,$g_categories;
  global $col_tablemediumbg,$col_tablelightbg;
  global $col_tableshinebg,$col_tabledarkbg;
  global $col_tableheaderbg,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2;
  global $col_tableframe,$col_errcolfg;
  global $g_stddatetime,$g_stddate;
  global $g_users;
  global $g_user,$g_dis;

  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='1'>";
  echo "<TR BGCOLOR='$col_tableframe'><TD>";
  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='0'>";
  echo "<TR BGCOLOR='$col_tableheaderbg'>";
  echo "<TD><FONT COLOR='$col_tableheaderfg'>ID$g_dis</FONT></TD>";
  echo "<TD WIDTH='100%'><FONT COLOR='$col_tableheaderfg'>Title$g_dis</FONT></TD>";
  echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Posted At$g_dis</FONT></TD>";
  echo "</TR>";

  $bgcol = $col_tablebg1;

  foreach($comments AS $commentid => $line)
  {
   $title = $line["Title"];
   $createdDate = $line["CreatedDate"];

   if($isNote)
   {
    $noteid = $line["NoteID"];
    $link = "<A HREF='?function=viewcomments&amp;noteid=$noteid'>$title</A>";
   }
   else if($isThread)
   {
    $threadid = $line["ThreadID"];
    $link = "<A HREF='?function=viewcomments&amp;threadid=$threadid'>$title</A>";
   }
   echo "<TR BGCOLOR='$bgcol'>";

   echo "<TD>$commentid$g_dis</TD>";
   echo "<TD>$link$g_dis</TD>";
   echo "<TD NOWRAP>".date($g_stddatetime,$createdDate)."</TD>";

   if($bgcol == $col_tablebg1)
   {
    $bgcol = $col_tablebg2;
   }
   else
   {
    $bgcol = $col_tablebg1;
   }

   echo "</TR>";
  }

  echo "</TABLE></TD></TR></TABLE>";
 }

 function listMessages($messages,$folder,$order="",$orderby="")
 {
  global $col_tablemediumbg,$col_tablelightbg;
  global $col_tableshinebg,$col_tabledarkbg;
  global $col_tableheaderbg,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2;
  global $col_tableframe,$col_errcolfg;
  global $g_stddatetime,$g_stddate;
  global $g_currency;
  global $g_users;
  global $g_user;
  global $g_folders,$g_dis;

  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='1'>";
  echo "<TR BGCOLOR='$col_tableframe'><TD>";
  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='0'>";
  echo "<TR BGCOLOR='$col_tableheaderbg'>";
  echo "<TD></TD>";
  $ord = "";
  if($orderby=="MessageID" && ($order=="" || $order=="ASC"))
  {
   $ord = "&amp;order=DESC";
  }
  echo "<TD><A HREF='?function=messages&amp;folderid=$folder&amp;orderby=MessageID$ord'><FONT COLOR='$col_tableheaderfg'>ID$g_dis</FONT></A></TD>";
  $ord = "";
  if($orderby=="From" && ($order=="" || $order=="ASC"))
  {
   $ord = "&amp;order=DESC";
  }
  echo "<TD><A HREF='?function=messages&amp;folderid=$folder&amp;orderby=From$ord'><FONT COLOR='$col_tableheaderfg'>From$g_dis</FONT></A></TD>";
  $ord = "";
  if($orderby=="To" && ($order=="" || $order=="ASC"))
  {
   $ord = "&amp;order=DESC";
  }
  echo "<TD><A HREF='?function=messages&amp;folderid=$folder&amp;orderby=To$ord'><FONT COLOR='$col_tableheaderfg'>To$g_dis</FONT></A></TD>";

  if($folder=='unread' || $folder=='marked')
  {
   $ord = "";
   if($orderby=="Folder" && ($order=="" || $order=="ASC"))
   {
    $ord = "&amp;order=DESC";
   }
   echo "<TD><A HREF='?function=messages&amp;folderid=$folder&amp;orderby=Folder$ord'><FONT COLOR='$col_tableheaderfg'>Folder$g_dis</FONT></A></TD>";
  }
  $ord = "";
  if($orderby=="Title" && ($order=="" || $order=="ASC"))
  {
   $ord = "&amp;order=DESC";
  }
  echo "<TD WIDTH='100%'><A HREF='?function=messages&amp;folderid=$folder&amp;orderby=Title$ord'><FONT COLOR='$col_tableheaderfg'>Title$g_dis</FONT></A></TD>";
  $ord = "";
  if($orderby=="CreatedDate" && ($order=="" || $order=="ASC"))
  {
   $ord = "&amp;order=DESC";
  }
  echo "<TD NOWRAP><A HREF='?function=messages&amp;folderid=$folder&amp;orderby=CreatedDate$ord'><FONT COLOR='$col_tableheaderfg'>Created At$g_dis</FONT></A></TD>";
  if($folder!=2)
  {
   $ord = "";
   if($orderby=="ReadDate" && ($order=="" || $order=="ASC"))
   {
    $ord = "&amp;order=DESC";
   }
   echo "<TD NOWRAP><A HREF='?function=messages&amp;folderid=$folder&amp;orderby=ReadDate$ord'><FONT COLOR='$col_tableheaderfg'>Read At$g_dis</FONT></A></TD>";
  }

  if($folder!="sent")
  {
   echo "<TD></TD>"; // For checkbox
  }
  echo "</TR>";

  $bgcol = $col_tablebg1;

  foreach($messages AS $messageid => $message)
  {
   $from = $message->fromUserID;
   $to = $message->toUserID;
   $title = htmlentities($message->title,ENT_QUOTES);
   $createddate = date($g_stddatetime,$message->createdDate);
   $readdate = $message->readDate;
   $folderid = $message->folderID;

   $read = $message->isRead();
   $marked = $message->isMarked();

   $fromuser = $g_users->getUserByID($from);
   $touser = $g_users->getUserByID($to);

   if($readdate==0)
   {
    $readdate = "<EM>N/A</EM>";
   }
   else
   {
    $readdate = Date($g_stddatetime,$readdate);
   }

   if($folder=='unread' || $folder=='marked')
   {
    $foldertitle = htmlentities($g_folders->getTitleByID($folderid),ENT_QUOTES);
   }

   $image = "";

   if($folder!="sent")
   {
    if(!$read && !$marked)
    {
     $before = "<STRONG>";
     $after = "</STRONG>";
     $image = "unread";
    }
    else if($read && !$marked)
    {
     $before = "";
     $after = "";
     $image = "read";
    }
    else if(!$read && $marked)
    {
     $before = "<STRONG><EM>";
     $after = "</EM></STRONG>";
     $image = "markedunread";
    }
    else if($read && $marked)
    {
     $before = "<STRONG><EM>";
     $after = "</EM></STRONG>";
     $image = "marked";
    }
   }
   else
   {
    if(!$read)
    {
     $before = "<STRONG>";
     $after = "</STRONG>";
     $image = "unread";
    }
    else
    {
     $before = "";
     $after = "";
     $image = "read";
    }
   }
   echo "<TR BGCOLOR='$bgcol'>";
   echo "<TD><IMG SRC='".getImage("message/small/$image.gif")."' ALT=''/></TD>";
   echo "<TD>$before$messageid$g_dis$after</TD>";
   if(is_object($fromuser))
   {
    echo "<TD><A HREF='?function=viewprofile&amp;userid=$from'>$before".$fromuser->username."$after</A>$g_dis</TD>";
   }
   else
   {
    echo "<TD>".$before."N/A$after$g_dis</TD>";
   }
   echo "<TD><A HREF='?function=viewprofile&amp;userid=$to'>$before".$touser->username."$after</A>$g_dis</TD>";
   if($folder=='unread' || $folder=='marked')
   {
    echo "<TD NOWRAP>$before$foldertitle$after$g_dis</TD>";
   }

   echo "<TD><A HREF='?function=messages&amp;type=view&amp;messageid=$messageid'>$before$title$after</STRONG></A>$g_dis</TD>";

   echo "<TD NOWRAP>$before$createddate$g_dis$after</TD>";
   if($folder!=2)
   {
    echo "<TD NOWRAP>$before$readdate$g_dis$after</TD>";
   }
   if($folder!="sent")
   {
    echo "<TD><INPUT TYPE='CHECKBOX' NAME='fm_selected_$messageid'/></TD>";
   }
   if($bgcol == $col_tablebg1)
   {
    $bgcol = $col_tablebg2;
   }
   else
   {
    $bgcol = $col_tablebg1;
   }

   echo "</TR>";
  }

  echo "</TABLE></TD></TR></TABLE>";
 }

 function listThreads($threads)
 {
  global $col_tablemediumbg,$col_tablelightbg;
  global $col_tableshinebg,$col_tabledarkbg;
  global $col_tableheaderbg,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2;
  global $col_tableframe,$col_errcolfg;
  global $g_stddatetime,$g_stddate;
  global $g_users,$g_comments,$g_user,$g_dis;

  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='1'>";
  echo "<TR BGCOLOR='$col_tableframe'><TD>";
  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='0'>";
  echo "<TR BGCOLOR='$col_tableheaderbg'>";
  echo "<TD COLSPAN='2' WIDTH='100%'><FONT COLOR='$col_tableheaderfg'>Title$g_dis</FONT></TD>";
  echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Created By$g_dis</FONT></TD>";
  echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Date$g_dis</FONT></TD>";
  echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Replies$g_dis</FONT></TD>";
  echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Last$g_dis</FONT></TD>";
  echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Date</FONT></TD>";
  echo "</TR>";

  $bgcol = $col_tablebg1;

  foreach($threads AS $id => $thread)
  {
   $title = $thread->title;
   $createdByUserID = $thread->createdByUserID;
   $createdDate = $thread->createdDate;
   $createdByUsername = $thread->createdByUsername;
   $lastByUserID = $thread->lastByUserID;
   $lastDate = $thread->lastDate;
   $lastByUsername = $thread->lastByUsername;

   $last = true;
   if($thread->commentID == $thread->lastCommentID)
   {
    $last = false;
   }

   $commentcount = $g_comments->getCommentCountByThreadID($id,$thread->commentID);

   $image = "";
   if($thread->isSticky())
   {
    $image = "<IMG ALT='S' SRC='".getImage("forum/sticky.gif")."'/>";
   }

   if($thread->isLocked())
   {
    $image.= "<IMG ALT='L' SRC='".getImage("forum/locked.gif")."'/>";
   }

   if($thread->isHidden())
   {
    $image.= "<IMG ALT='H' SRC='".getImage("forum/hidden.gif")."'/>";
   }

   echo "<TR BGCOLOR='$bgcol'>";
   echo "<TD NOWRAP>$image</TD>";
   echo "<TD WIDTH='100%'><A HREF='?function=viewcomments&amp;threadid=$id'>".htmlentities($title,ENT_QUOTES)."$g_dis</A></TD>";
   echo "<TD><A HREF='?function=viewprofile&amp;userid=$createdByUserID'>$createdByUsername$g_dis</A></TD>";
   echo "<TD NOWRAP>".Date($g_stddatetime,$createdDate)."$g_dis</TD>";
   echo "<TD>$commentcount$g_dis</TD>";
   if($last)
   {
    echo "<TD><A HREF='?function=viewprofile&amp;userid=$lastByUserID'>$lastByUsername$g_dis</A></TD>";
    echo "<TD NOWRAP>".Date($g_stddatetime,$lastDate)."$g_dis</TD>";
   }
   else
   {
    echo "<TD></TD><TD></TD>";
   }
   echo "</TR>";

   if($bgcol == $col_tablebg1)
   {
    $bgcol = $col_tablebg2;
   }
   else
   {
    $bgcol = $col_tablebg1;
   }
  }

  echo "</TABLE></TD></TR></TABLE>";

 }

 function listRecentForumActivity($list)
 {
  global $g_dis;
  global $col_tableframe,$col_tableheaderng,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2,$col_tableheaderbg;
  global $g_comments,$g_forumicons;

  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='1'>";
  echo "<TR BGCOLOR='$col_tableframe'><TD>";
  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='0'>";
  echo "<TR BGCOLOR='$col_tableheaderbg'>";
  $colspan=1;
  if($g_forumicons)
  {
   $colspan=2;
  }
  echo "<TD COLSPAN='$colspan' WIDTH='100%'><FONT COLOR='$col_tableheaderfg'>Title$g_dis</FONT></TD>";
  echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Replies$g_dis</FONT></TD>";
  echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Last post$g_dis</FONT></TD>";
  echo "</TR>";

  $bgcol = $col_tablebg1;

  foreach($list AS $id => $row)
  {

   $title = $row["Title"];
   $commentid = $row["CommentID"];
   $userid = $row["LastByUserID"];
   $username = $row["LastByUsername"];
   $forumid = $row["ForumID"];

   $issticky = $row["IsSticky"];
   $islocked = $row["IsLocked"];
   $ishidden = $row["IsHidden"];

   $count = $g_comments->getCommentCountByThreadID($id,$commentid);

   echo "<TR BGCOLOR='$bgcol'>";

   if($g_forumicons)
   {
    echo "<TD NOWRAP><A HREF='?function=viewforum&amp;forumid=$forumid'><IMG BORDER='0' ALT='' SRC='images/forumicons/$forumid.gif' ALIGN='TOP'/>$g_dis</A></TD>";
   }
   echo "<TD WIDTH='100%'><A HREF='?function=viewcomments&amp;threadid=$id'>".htmlentities($title,ENT_QUOTES)."</A>$g_dis</TD>";
   echo "<TD>$count$g_dis</TD>";
   echo "<TD><A HREF='?function=viewprofile&amp;userid=$userid'>$username</A>$g_dis</TD>";

   echo "</TR>";

   if($bgcol == $col_tablebg1)
   {
    $bgcol = $col_tablebg2;
   }
   else
   {
    $bgcol = $col_tablebg1;
   }
  }

  echo "</TABLE></TD></TR></TABLE>";
 }

 function listDirectories($list,$current)
 {
  global $col_tableframe,$col_tableheaderbg,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2;
  global $g_user;

  echo "<TABLE WIDTH='50%' BORDER='0' CELLPADDING='1' CELLSPACING='1'>";
  echo "<TR BGCOLOR='$col_tableframe'><TD>";
  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='0'>";
  echo "<TR BGCOLOR='$col_tableheaderbg'>";
  echo "<TD WIDTH='100%' NOWRAP><FONT COLOR='$col_tableheaderfg'>Directory</FONT></TD>";
  if(is_object($g_user) && $g_user->access("MODERATOR"))
  {
   echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Action</FONT></TD>";
  }
  echo "</TR>";

  if(is_object($current))
  {
   echo "<TR BGCOLOR='$col_tablebg1'>";
   echo "<TD>";
   echo "<A HREF='?function=viewpages&amp;directoryid=$current->parentDirectoryID'>&lt;- Parent</A>";
   echo "</TD>";
   if(is_object($g_user) && $g_user->access("MANAGEDIRECTORIES"))
   {
    echo "<TD></TD>";
   }
   $bgcol = $col_tablebg2;
  }
  else
  {
   $bgcol = $col_tablebg1;
  }

  foreach($list AS $id => $row)
  {
   $directoryid = $row->directoryID;
   $title = htmlentities(ucfirst($row->title),ENT_QUOTES);

   echo "<TR BGCOLOR='$bgcol'>";
   echo "<TD NOWRAP>";
   echo "<A HREF='?function=viewpages&amp;directoryid=$directoryid'>-&gt; $title</A>";
   echo "</TD>";

   if(is_object($g_user) && $g_user->access("MANAGEDIRECTORIES"))
   {
    echo "<TD NOWRAP>";
    echo functionLink("?function=editdirectory&amp;directoryid=$directoryid","Edit");
    echo functionLink("?function=deletedirectory&amp;directoryid=$directoryid","Delete");
    echo "</TD>";
   }

   echo "</TR>";

   if($bgcol == $col_tablebg1)
   {
    $bgcol = $col_tablebg2;
   }
   else
   {
    $bgcol = $col_tablebg1;
   }
  }

  echo "</TABLE></TD></TR></TABLE>";
 }

 function listFiles($list,$ownerType,$ownerID,$ismanager=false)
 {
  global $col_tableframe,$col_tableheaderbg,$col_tableheaderfg;
  global $col_tablebg1,$col_tablebg2,$col_errcolfg;
  global $g_user,$g_users,$g_stddatetime,$g_dis,$g_attachurl;

  if($ownerType=="NOTE")
  {
   $urlid = "noteid=$ownerID";
   $basedir = "note";
  }
  else if($ownerType=="PAGE")
  {
   $urlid = "pageid=$ownerID";
   $basedir = "page";
  }
  else
  {
   return;
  }

  echo "<TABLE WIDTH='50%' BORDER='0' CELLPADDING='1' CELLSPACING='1'>";
  echo "<TR BGCOLOR='$col_tableframe'><TD>";
  echo "<TABLE WIDTH='100%' BORDER='0' CELLPADDING='1' CELLSPACING='0'>";
  echo "<TR BGCOLOR='$col_tableheaderbg'>";
  echo "<TD><FONT COLOR='$col_tableheaderfg'>Filename$g_dis</FONT></TD>";
  echo "<TD><FONT COLOR='$col_tableheaderfg'>Size$g_dis</FONT></TD>";
  echo "<TD><FONT COLOR='$col_tableheaderfg'>By$g_dis</FONT></TD>";
  echo "<TD><FONT COLOR='$col_tableheaderfg'>Date$g_dis</FONT></TD>";
  echo "<TD WIDTH='100%' NOWRAP><FONT COLOR='$col_tableheaderfg'>Description$g_dis</FONT></TD>";
  if($ismanager)
  {
   echo "<TD NOWRAP><FONT COLOR='$col_tableheaderfg'>Action</FONT></TD>";
  }
  echo "</TR>";

  $bgcol = $col_tablebg1;

  foreach($list AS $filename => $attachment)
  {
   if($attachment->isPublic() || $ismanager)
   {
    $size = $attachment->size;
    $createdByUserID = $attachment->createdByUserID;
    $createdDate = $attachment->createdDate;
    $description = htmlentities($attachment->description,ENT_QUOTES);

    $createdByUser = $g_users->getUserByID($createdByUserID);
    $createdByUsername = $createdByUser->username;
    echo "<TR BGCOLOR='$bgcol'>";

    echo "<TD NOWRAP><A HREF='$g_attachurl/$basedir/$ownerID/$filename'>";
    echo htmlentities($filename,ENT_QUOTES);
    echo "</A>$g_dis</TD>";


    echo "<TD>$size$g_dis</TD>";
    echo "<TD><A HREF='?function=viewprofile&amp;userid=$createdByUserID'>$createdByUsername</A>$g_dis</TD>";
    echo "<TD NOWRAP>".date($g_stddatetime,$createdDate)."$g_dis</TD>";
    if($attachment->isPublic())
    {
     echo "<TD NOWRAP>$description$g_dis</TD>";
    }
    else
    {
     echo "<TD NOWRAP><FONT COLOR='$col_errcolfg'>HIDDEN </FONT>$description$g_dis</TD>";
    }

    if($ismanager)
    {
     echo "<TD NOWRAP>";
     echo functionLink("?function=viewfiles&amp;$urlid&amp;filename=".urlEncode($filename)."&amp;action=edit","Edit");
     if($attachment->isPublic())
     {
      echo functionLink("?function=viewfiles&amp;$urlid&amp;filename=".urlEncode($filename)."&amp;action=hide","Hide");
     }
     else
     {
      echo functionLink("?function=viewfiles&amp;$urlid&amp;filename=".urlEncode($filename)."&amp;action=expose","Expose");
     }
     echo $g_dis.functionLink("?function=viewfiles&amp;$urlid&amp;filename=".urlEncode($filename)."&amp;action=delete","Delete");
     echo "</TD>";
    }

    echo "</TR>";

    if($bgcol == $col_tablebg1)
    {
     $bgcol = $col_tablebg2;
    }
    else
    {
     $bgcol = $col_tablebg1;
    }
   }
  }
  echo "</TABLE></TD></TR></TABLE>";
 }



 function functionLink($link,$title,$graphic=true)
 { 
  global $g_themepath;

  if($graphic && file_exists("$g_themepath/buttons/$title.gif"))
  {
   $out = "<A HREF='$link'><IMG ALIGN='TOP' BORDER='0' SRC='$g_themepath/buttons/$title.gif' ALT='[$title]'/></A>";
  }
  else if($graphic && file_exists("images/buttons/$title.gif"))
  {
   $out = "<A HREF='$link'><IMG ALIGN='TOP' BORDER='0' SRC='images/buttons/$title.gif' ALT='[$title]'/></A>";
  }
  else
  {
   $out = "<A HREF='$link'>[$title]</A>";
  }

  return $out;
 }

 function insertDis($level,$template="&nbsp;&nbsp;")
 {
  $result = $template;

  for($i=0;$i<$level;$i++)
  {
   $result.= $template;
  }

  return $result;
 }

 function getImage($image)
 {
  global $g_themepath;

  if(file_exists("$g_themepath/$image"))
  {
   return "$g_themepath/$image";
  }
  else if(file_exists("images/$image"))
  {
   return "images/$image";
  }

  return "";
 }



?>
